\documentclass{standalone}

\input{../../macros/macros}

\usepackage{../../../msc}

\begin{document}

\begin{msc}[msc keyword=, draw frame = none, instance distance=5cm]{}
\declinst{a}{$\pubkey{A}, \seckey{A}$}{Initiating device A}
\declinst{b}{$\pubkey{B}, \seckey{B}$}{Responding device B}
\action*{nonces $N_{A0}, N_{A1}$}{a}
\action*{nonce $N_{B0}, N_{B1}$}{b}
\nextlevel[3]
\mess{$\pair{init}{\pair{A}{\pubkey{A}}}$}{a}{b}
\nextlevel[1.5]
\mess{$\pair{resp}{\pair{B}{\pubkey{B}}}$}{b}{a}
\nextlevel[1.5]
\action*{$DHkey = P256(\seckey{A}, \pubkey{B})$}{a}
\action*{$DHkey = P256(\seckey{B}, \pubkey{A})$}{b}
\nextlevel[1.5]
\action*{$C_a = f1(\pubkey{A}, \pubkey{B}, N_{A0}, N_{A1})$}{a}
\action*{$C_b = f1(\pubkey{B}, \pubkey{A}, N_{B0}, N_{B1})$}{b}
\nextlevel[3]
\mess{$C_a$}{a}{b}
\nextlevel[1.5]
\mess{$C_b$}{b}{a}
\nextlevel[1.5]
\mess*{$N_{A0}$}{a}{b}
\measure{max $\Delta$}{a}{a}[1.5]
\nextlevel[1.5]
\mess*{$N_{A0} \xor N_{B0}$}{b}{a}
\nextlevel[1.5]
\mess*{$N_{B1}$}{b}{a}
\measure[r]{max $\Delta$}{b}{b}[1.5]
\nextlevel[1.5]
\mess*{$N_{A1} \xor N_{B1}$}{a}{b}
\nextlevel[1.5]
\action*{$E_A = f3(DHkey, N_{A0}, N_{A1}, N_{B0}, N_{B1}, A, B)$}{a}
\action*{$E_B = f3(DHkey, N_{B0}, N_{B1}, N_{A0}, N_{A1}, B, A)$}{b}
\nextlevel[3]
\mess{$E_A$}{a}{b}
\nextlevel[1.5]
\mess{$E_B$}{b}{a}
\nextlevel[1.5]
\action*{$LK = f2(DHkey, N_{A0}, N_{A1}, N_{B0}, N_{B1}, A, B)$}{a}
\action*{$LK = f2(DHkey, N_{A0}, N_{A1}, N_{B0}, N_{B1}, A, B)$}{b}
\nextlevel[3]
\condition*{$LK$ is secret}{a}
\condition*{$LK$ is secret}{b}
\nextlevel[2]
\condition*{$A$ is communicating with $B$}{a}
\condition*{$B$ is communicating with $A$}{b}
\nextlevel[1]
\end{msc}

\end{document}